#include <windows.h>
#include <Commdlg.h>
#include <string.h>
#include <string>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <bitset>
#include <sys/time.h>
#include "resource.h"
#include <cstring>
#include <iomanip>
#include <fstream>
#include <sstream>

#define _int8 unsigned char
#define _int16 short
#define _int32 long
#define _int64 long long

using namespace std;

//VARIABLE DECLARATIONS FOR SIMULATOR
static const unsigned int IMSize = 256;
static const unsigned int DMSize = 256;
bool firstStep = 1;
bool forward[41];
string regLabel[32] = {"(z0)","(at)","(v0)","(v1)","(a0)","(a1)","(a2)","(a3)","(t0)","(t1)","(t2)","(t3)","(t4)","(t5)","(t6)","(t7)","(s0)","(s1)","(s2)","(s3)","(s4)","(s5)","(s6)","(s7)","(t8)","(t9)","(k0)","(k1)","(gp)","(sp)","(fp)","(ra)"};
float ClkCnt, InsCnt = 0.0;
float CPI = 0.0;
_int32 runawayProg = 0;
unsigned char state = 0;
bool state32, state33, state34, state35 = 0;
bool opthaz28, opthaz24, oojrhaz, oobhaz, obohaz = 0;

//registers
_int32 regFile[32];
_int64 hilo = 0;

//stage1 variables
_int32 INST1,INST14,INST18,CPC=0;
_int32 PCP41 = 0;
bool Iflush1, stall1, Branch, Branch4, Branch8 = 0;

//stage2 variables
_int32 INST2,INST24,INST28,sPCP42,SEIM2,SEIM24,SEIM28,Q0,Q1,Q2,Q3,Q4,Q5,address2ID = 0;
_int32 PCP42 = 4;
bool stall2,Iflush2,zero,neg,zero4,neg4,zero8,neg8,RegWrite2,RegDst2,ALUsrc2,Memtoreg2,lw2,sw2,Jump2,Jump24,Jump28,mult2,multa2,molo2,mohi2,sext,Beq,Bne,Bgt,Blt,JR,sext4,Beq4,Bne4,Bgt4,Blt4,JR4,sext8,Beq8,Bne8,Bgt8,Blt8,JR8 = 0;
_int8 ALUop, ALUctr2 = 0;

//stage3 variables
_int32 INST3,sPCP43,SEIM3,rs,rt,ALUout3 = 0;
_int32 PCP43 = 4;
bool stall3,Iflush3,RegWrite3,RegDst3,ALUsrc3,Memtoreg3,lw3,sw3,Jump3,mult3,multa3,molo3,mohi3 = 0;
_int8 ALUctr3 = 0;
_int64 prod3 = 0;

//stage4 variables
_int32 INST4,sPCP44,inRamData, RamOut, ALUout4 = 0;
_int32 PCP44 = 4;
bool stall4,Iflush4,RegWrite4,RegDst4,Memtoreg4,lw4,sw4,Jump4,mult4,multa4,molo4,mohi4 = 0;
_int64 prod4,hilo4 = 0;

//stage5 variables
_int32 INST5,sPCP45,RamData,ALUout5,WBData5 = 0;
_int32 PCP45 = 4;
bool RegWrite5,RegDst5,Memtoreg5,lw5,Jump5,molo5,mohi5,WE5 = 0;
_int8 RD5=0;
_int64 hilo5 = 0;

//VARIABLE DECLARATIONS FOR GUI
HINSTANCE hInst;
string iBrowseFname, dBrowseFname;
//string inFname, outFname;
char* PStepAmount;
char* PInstrucFname;
char* PDataFname;
char InstrucFname[255], DataFname[255], StepAmount[255];
long DMem[IMSize], IMem[IMSize];
string Inss[IMSize+1], instrucBinary[IMSize];
ofstream logFile;ofstream dataMem;ofstream instrucMem;
ofstream ofTemp;
ifstream ifTemp;
string sOutput, sTemp;

//FUNCTION DECLARATIONS
string DoFileInput(HWND hwnd);
string DoFileOutput(HWND hwnd);
string lineParse (ifstream &file);
void loadFile(string iFname, string dFname);
void output(HWND hwnd);
void updatescreen();
void clock1();
void resetMem();
unsigned char getrs(_int32 x);
unsigned char getrt(_int32 x);
unsigned char getrd(_int32 x);
_int32 getop(_int32 x);
_int32 getfunc(_int32 x);
bool nrt(_int32 x);
bool nit(_int32 x);
bool loadw(_int32 x);
bool storew(_int32 x);
bool jrin(_int32 x);
bool bri(_int32 x);

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    switch(uMsg)
    {
        case WM_INITDIALOG:

            return TRUE;

        case WM_CLOSE:
            remove("temp.txt");
            EndDialog(hwndDlg, 0);
            return TRUE;

        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDC_BTN_STEP:
                    if(firstStep){
                        firstStep = 0;
                        clock1();clock1();clock1();clock1();clock1();
                        ClkCnt = 5;
                        InsCnt = 1;
                        CPI = ClkCnt/InsCnt;

                        GetDlgItemText(hwndDlg, IDC_TEXT_STEPINPUT, PStepAmount, 255);
                        PStepAmount = StepAmount;
                        GetDlgItemText(hwndDlg, IDC_TEXT_STEPINPUT, PStepAmount, 255);
                        PStepAmount = StepAmount;
                        if (atoi(StepAmount) > 0) {
                            for (int i = 5; i<atoi(StepAmount); i++) {
                                if((unsigned)((PCP45-4) >> 2) < (IMSize-4)){
                                    clock1();ClkCnt++;CPI = ClkCnt/InsCnt;}
                            }
                        }

                    }else{
                        GetDlgItemText(hwndDlg, IDC_TEXT_STEPINPUT, PStepAmount, 255);
                        PStepAmount = StepAmount;
                        GetDlgItemText(hwndDlg, IDC_TEXT_STEPINPUT, PStepAmount, 255);
                        PStepAmount = StepAmount;
                        if (atoi(StepAmount) > 0) {
                            for (int i = 0; i<atoi(StepAmount); i++) {
                                if((unsigned)((PCP45-4) >> 2) < (IMSize-4)){
                                    clock1();ClkCnt++;CPI = ClkCnt/InsCnt;}
                            }
                        }
                        else {
                            if((unsigned)((PCP45-4) >> 2) < (IMSize-4)){
                                    clock1();ClkCnt++;CPI = ClkCnt/InsCnt;}
                        }
                    }
                    updatescreen();
                    SetDlgItemText(hwndDlg, IDC_TEXT_WINDOW, sOutput.c_str());
                    sOutput = "";
                    return TRUE;

                case IDC_BTN_EXECUTE:
                    while((unsigned)((PCP45) >> 2) < (IMSize-4)){
                        runawayProg++;
                        if(firstStep){
                            firstStep = 0;
                            clock1();clock1();clock1();clock1();clock1();
                            ClkCnt = 4;
                            InsCnt = 1;
                            CPI = ClkCnt/InsCnt;
                        }else{
                            clock1();
                            ClkCnt++;
                            CPI = ClkCnt/InsCnt;
                        }
                        if(runawayProg>500000){
                            updatescreen();
                            SetDlgItemText(hwndDlg, IDC_TEXT_WINDOW, sOutput.c_str());
                            sOutput = "";
                            cout << "\t\t\t     Runaway Program\n\n";
                            cout << "\t\t\t   Execution Terminated\n";
                            break;
                        }
                    }

                    //Output Instruction Memory
                    instrucMem.open("contents_instruction.txt");
                    for (int i=0; i < 100; i++) {
                        instrucMem << setfill('0') << setw(8) << uppercase << hex << i*4
                         << " :: " << setw(8) << uppercase << hex << IMem[i]
                         << " :: " << Inss[i] << "\n";
                    }

                    instrucMem.close();

                    //Output Data Memory
                    dataMem.open("contents_data.txt");
                    dataMem << setfill(' ') << setw(18) << 0 << setw(9) << 4
                    << setw(9) << 8 << setw(9) << "C" << setw(9);
                    for (int i=0; i < 256; i++) {
                        if (i % 4 == 0) {
                            dataMem << "\n" << setfill('0') << setw(8) << uppercase << hex << 0xFFFFFC00+(4*i) << ": ";
                        }
                        dataMem << setfill('0') << setw(8) << uppercase << hex << DMem[i] << " ";
                    }
                    dataMem.close();

                    //Update Screen
                    updatescreen();
                    SetDlgItemText(hwndDlg, IDC_TEXT_WINDOW, sOutput.c_str());
                    sOutput = "";
                    cout << "\t\t\t   Execution Terminated\n";
//                    SetDlgItemText(hwndDlg, IDC_TEXT_WINDOW,
//                    "This is a character string.\r\nThis is a new character string.");
//                    SetDlgItemText(hwndDlg, IDC_TEXT_WINDOW,
//                    "This is a character string.\r\nThis is a new character string.");
                    return TRUE;

                case IDC_BTN_VIEWDATAMEMORY:
                    dataMem.open("contents_data.txt");
                    dataMem << setfill(' ') << setw(18) << 0 << setw(9) << 4
                    << setw(9) << 8 << setw(9) << "C" << setw(9);
                    for (int i=0; i < 256; i++) {
                        if (i % 4 == 0) {
                            dataMem << "\n" << setfill('0') << setw(8) << uppercase << hex << 0xFFFFFC00+(4*i) << ": ";
                        }
                        dataMem << setfill('0') << setw(8) << uppercase << hex << DMem[i] << " ";
                    }
                    dataMem.close();

                    HWND data;
                    ShellExecute(data, "open", "contents_data.txt", NULL, NULL,
                    SW_SHOWNORMAL);
                    return TRUE;

                case IDC_BTN_VIEWINSTRUCTIONMEMORY:
                    instrucMem.open("contents_instruction.txt");
                    for (int i=0; i < 100; i++) {
                        instrucMem << setfill('0') << setw(8) << uppercase << hex << i*4
                         << " :: " << setw(8) << uppercase << hex << IMem[i]
                         << " :: " << Inss[i] << "\n";
                    }

                    instrucMem.close();

                    HWND instruction;
                    ShellExecute(instruction, "open", "contents_instruction.txt", NULL, NULL,
                    SW_SHOWNORMAL);

                    return TRUE;
                case IDC_BTN_VIEWLOGFILE:
                    HWND log;
                    ShellExecute(log, "open", "log.txt", NULL, NULL,
                    SW_SHOWNORMAL);
                    return TRUE;

                case IDC_BTN_LOADFILE:
                    firstStep = 1;ClkCnt = 0;InsCnt = 0.0;CPI = 0.0;runawayProg = 0;
                    hilo = 0;INST1 = 0;CPC = 0; PCP41 = 0;Iflush1 = 0; stall1 = 0; Branch = 0;
                    PCP42 = 4;INST2 = 0;SEIM2 = 0;Q0 = 0;Q1 = 0;stall2 = 0;Iflush2 = 0;zero = 0;
                    neg = 0;RegWrite2 = 0;RegDst2 = 0;ALUsrc2 = 0;Memtoreg2 = 0;lw2 = 0;sw2 = 0;
                    Jump2 = 0;mult2 = 0;multa2 = 0;molo2 = 0;mohi2 = 0;sext = 0;Beq = 0;Bne = 0;
                    Bgt = 0;Blt = 0;JR = 0;ALUop = 0; ALUctr2 = 0;PCP43 = 4;INST3 = 0;SEIM3 = 0;
                    rs = 0;rt = 0;ALUout3 = 0;stall3 = 0;Iflush3 = 0;RegWrite3 = 0;RegDst3 = 0;
                    ALUsrc3 = 0;Memtoreg3 = 0;lw3 = 0;sw3 = 0;Jump3 = 0;mult3 = 0;multa3 = 0;
                    molo3 = 0;mohi3 = 0;ALUctr3 = 0;prod3 = 0;PCP44 = 4;INST4 = 0;inRamData = 0;
                    RamOut = 0; ALUout4 = 0;stall4 = 0;Iflush4 = 0;RegWrite4 = 0;RegDst4 = 0;
                    Memtoreg4 = 0;lw4 = 0;sw4 = 0;Jump4 = 0;mult4 = 0;multa4 = 0;molo4 = 0;mohi4 = 0;
                    prod4 = 0;hilo4 = 0;PCP45 = 4;INST5 = 0;RamData = 0;ALUout5 = 0;WBData5 = 0;
                    RegWrite5 = 0;RegDst5 = 0;Memtoreg5 = 0;lw5 = 0;Jump5 = 0;molo5 = 0;mohi5 = 0;WE5 = 0;RD5=0;hilo5 = 0;
                    INST14 =0; INST18 =0; INST24 =0; INST28 = 0; state = 0; state32 = 0;state33 = 0;state34 = 0;state35 = 0;
                    sPCP42 = 0; sPCP43 = 0; sPCP44 = 0; sPCP45 = 0; SEIM2 = 0; SEIM24 = 0; SEIM28 = 0;
                    //Zero the loaded instruction and data memorys
                    resetMem();

                    PInstrucFname = InstrucFname;
                    PDataFname = DataFname;
                    GetDlgItemText(hwndDlg, IDC_TEXT_InstrucINPUT, PInstrucFname, 255);
                    GetDlgItemText(hwndDlg, IDC_TEXT_DataINPUT, PDataFname, 255);
                    loadFile(InstrucFname, DataFname);
                    updatescreen();
                    SetDlgItemText(hwndDlg, IDC_TEXT_WINDOW, sOutput.c_str());
                    sOutput = "";
                    return TRUE;

                case IDC_BTN_RESET:
                    //Reinitialize all variables to 0
                    firstStep = 1;ClkCnt = 0;InsCnt = 0.0;CPI = 0.0;runawayProg = 0;
                    hilo = 0;INST1 = 0;CPC = 0; PCP41 = 0;Iflush1 = 0; stall1 = 0; Branch = 0;
                    PCP42 = 4;INST2 = 0;SEIM2 = 0;Q0 = 0;Q1 = 0;stall2 = 0;Iflush2 = 0;zero = 0;
                    neg = 0;RegWrite2 = 0;RegDst2 = 0;ALUsrc2 = 0;Memtoreg2 = 0;lw2 = 0;sw2 = 0;
                    Jump2 = 0;mult2 = 0;multa2 = 0;molo2 = 0;mohi2 = 0;sext = 0;Beq = 0;Bne = 0;
                    Bgt = 0;Blt = 0;JR = 0;ALUop = 0; ALUctr2 = 0;PCP43 = 4;INST3 = 0;SEIM3 = 0;
                    rs = 0;rt = 0;ALUout3 = 0;stall3 = 0;Iflush3 = 0;RegWrite3 = 0;RegDst3 = 0;
                    ALUsrc3 = 0;Memtoreg3 = 0;lw3 = 0;sw3 = 0;Jump3 = 0;mult3 = 0;multa3 = 0;
                    molo3 = 0;mohi3 = 0;ALUctr3 = 0;prod3 = 0;PCP44 = 4;INST4 = 0;inRamData = 0;
                    RamOut = 0; ALUout4 = 0;stall4 = 0;Iflush4 = 0;RegWrite4 = 0;RegDst4 = 0;
                    Memtoreg4 = 0;lw4 = 0;sw4 = 0;Jump4 = 0;mult4 = 0;multa4 = 0;molo4 = 0;mohi4 = 0;
                    prod4 = 0;hilo4 = 0;PCP45 = 4;INST5 = 0;RamData = 0;ALUout5 = 0;WBData5 = 0;
                    RegWrite5 = 0;RegDst5 = 0;Memtoreg5 = 0;lw5 = 0;Jump5 = 0;molo5 = 0;mohi5 = 0;WE5 = 0;RD5=0;hilo5 = 0;
                    INST14 =0; INST18 =0; INST24 =0; INST28 = 0; state = 0; state32 = 0;state33 = 0;state34 = 0;state35 = 0;
                    sPCP42 = 0; sPCP43 = 0; sPCP44 = 0; sPCP45 = 0; SEIM2 = 0; SEIM24 = 0; SEIM28 = 0;
                    //Zero the loaded instruction and data memorys
                    resetMem();
                    return TRUE;
                case IDC_BTN_BROWSEI:
                    iBrowseFname = DoFileInput(hwndDlg);        //Returned string filename
                    SetDlgItemText(hwndDlg, IDC_TEXT_InstrucINPUT, iBrowseFname.c_str());
                    return TRUE;

                case IDC_BTN_BROWSED:
                    dBrowseFname = DoFileOutput(hwndDlg);        //Returned string filename
                    SetDlgItemText(hwndDlg, IDC_TEXT_DataINPUT, dBrowseFname.c_str());
                    return TRUE;

                case IDC_BTN_QUIT:
                    remove("temp.txt");
                    DestroyWindow(hwndDlg);
                    return FALSE;
            }
    }

    return FALSE;
}

//Program Main
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
    hInst = hInstance;

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    logFile.open("log.txt");                            //Open the Log File


    resetMem();

    // The user interface is a modal dialog box
    return DialogBox(hInstance, MAKEINTRESOURCE(DLG_MAIN), NULL, DialogProc);
}

//Handles the input file selection dialog
string DoFileInput(HWND hwnd) {
	OPENFILENAME ofn;
	char szFileName[MAX_PATH] = "";

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "txt";

	GetOpenFileName(&ofn);

	return ofn.lpstrFile;
}

//Handles the output file selection dialog
string DoFileOutput(HWND hwnd) {
	OPENFILENAME ofn;
	char szFileName[MAX_PATH] = "";

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "txt";

	GetOpenFileName(&ofn);

	return ofn.lpstrFile;
}

void loadFile(string iFname, string dFname) {
    ifstream iFile, dFile;

    string line;                                        //This will store a retreived line from the parsed files (temp variable)
    int b=0, i=0, d=0;                                  //b - BInary Counter i - Instruction Counter d - Data Counter


    //Open Files
    iFile.open(iFname.c_str());
    if (iFile.is_open()) {}
    else {
        MessageBox(NULL,"Please select an instruction file.", "Success", MB_OK);
        return;
    }
    dFile.open(dFname.c_str());
    if (dFile.is_open()) {}
    else {
        MessageBox(NULL, "Please select a data file.", "Success", MB_OK);
        return;
    }

    //Output headings to Log File
    logFile << "\n\n*******************************************Contents of Instruction Memory*******************************************\n";
    logFile << "Memory Location\t\tBinary Value\t\t\t\tDecimal Value\t\tInstruction\n";

    //Parse Instruction File
    while (!iFile.eof()) {
        line = lineParse(iFile);
        if (line == "") {}
        else if (line[0] == '0' || line[0] == '1') {
            instrucBinary[b] = line;
            bitset<32> bitInt(line);
            IMem[b] = bitInt.to_ulong();
            b++;
        }
        else {
            Inss[i] = line;
            i++;
        }
    }

    //Verify Contents of Instruction Memory by outputting to Log File
    for (int j=0; j < (max(b,i)-1); j++) {
        logFile << j << "\t\t\t" << instrucBinary[j] << "\t" << IMem[j] << "\t\t\t" << Inss[j] << "\n";
    }

    //Output headings to Log File
    logFile << "\n\n***********************************************Contents of Data Memory**********************************************\n";
    logFile << "Memory Location\t\tHexadecimal Value\t\tDecimal Value\n";

    //Parse Data File
    while (!dFile.eof()) {
        line = lineParse(dFile);
        DMem[d] = strtoul(line.c_str(), NULL, 0);
        logFile << d << "\t\t\t" << line << "\t\t\t" << DMem[d] << "\n";
        d++;
    }

    //Cleanup by closing files
    iFile.close();
    dFile.close();
}

string lineParse (ifstream &file) {
    string parse;
    getline(file,parse);  //read the text file until the SPACE character is found

    while (parse[0] == '-' || parse[0] == '\n') {
        parse = parse.erase(0,1);
    }
    return (parse);
}


void updatescreen(){
ofTemp.open("temp.txt");
//cout << setfill('_') << setw(80) << "_" << endl;
//ofTemp << setfill('_') << setw(80) << "_" << endl;

for (int i=0; i<8; i++) {
    cout << " " << setfill('0') << "R" << setw(2) << dec << i << regLabel[i] << " = " << setw(8) << uppercase << hex << regFile[i] << "  ";
    ofTemp << " " << setfill('0') << "R" << setw(2) << dec << i << regLabel[i] << " = " << setw(8) << uppercase << hex << regFile[i] << "  ";
    cout << setfill('0') << "R" << setw(2) << dec << i+8 << regLabel[i+8] << " = " << setw(8) << uppercase << hex << regFile[i+8] << "  ";
    ofTemp << setfill('0') << "R" << setw(2) << dec << i+8 << regLabel[i+8] << " = " << setw(8) << uppercase << hex << regFile[i+8] << "  ";
    cout << setfill('0') << "R" << setw(2) << dec << i+16 << regLabel[i+16] << " = " << setw(8) << uppercase << hex << regFile[i+16] << "  ";
    ofTemp << setfill('0') << "R" << setw(2) << dec << i+16 << regLabel[i+16] << " = " << setw(8) << uppercase << hex << regFile[i+16] << "  ";
    cout << setfill('0') << "R" << setw(2) << dec << i+24 << regLabel[i+24] << " = " << setw(8) << uppercase << hex << regFile[i+24] << endl;
    ofTemp << setfill('0') << "R" << setw(2) << dec << i+24 << regLabel[i+24] << " = " << setw(8) << uppercase << hex << regFile[i+24] << endl;
}
cout.setf(ios::showpoint);
cout << endl << " hilo = " << setfill('0') << setw(16) << uppercase << hex << hilo << "\t\t\t\t\t   CPI = " << setprecision(5) << CPI << endl;
ofTemp << endl << " hilo = " << setfill('0') << setw(16) << uppercase << hex << hilo << "\t\t\t\t\t   CPI = " << setprecision(5) << CPI << endl;
cout << "\t\t\t\t\t\t\t       Clk Cnt = " << setfill('0') << setw(6) << dec << (int)ClkCnt << endl << " Next Instruction(s)" <<  "\t\t\t\t\t       Ins Cnt = " << setfill('0') << setw(6) << dec << (int)InsCnt << endl << " ";
ofTemp << "\t\t\t\t\t\t\t       Clk Cnt = " << setfill('0') << setw(6) << dec << (int)ClkCnt << endl << " Next Instruction(s)" <<  "\t\t\t\t\t       Ins Cnt = " << setfill('0') << setw(6) << dec << (int)InsCnt << endl << " ";

if(firstStep){
    cout << setfill('0') << setw(8) << uppercase << hex << CPC << " :: " << setw(8) << uppercase << hex << IMem[CPC >> 2] << " :: " << Inss[CPC >> 2] << endl;
    ofTemp << setfill('0') << setw(8) << uppercase << hex << CPC << " :: " << setw(8) << uppercase << hex << IMem[CPC >> 2] << " :: " << Inss[CPC >> 2] << endl;
}else if(Iflush4){
    cout<< "          ::          :: FLUSH" << endl;
    ofTemp<< "          ::          :: FLUSH" << endl;
}else if(stall4){
    cout<< "          ::          :: STALL" << endl;
    ofTemp<< "          ::          :: STALL" << endl;
}else if (state34){
    cout << " " << "\nsPCP44: " << sPCP44 << "\n\n";
    cout << " " << setfill('0') << setw(8) << uppercase << hex << (sPCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(sPCP44-4) >> 2] << " :: " << Inss[(sPCP44-4) >> 2] << endl;
    ofTemp << setfill('0') << setw(8) << uppercase << hex << (sPCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(sPCP44-4) >> 2] << " :: " << Inss[(sPCP44-4) >> 2] << endl;
}else{
    cout << setfill('0') << setw(8) << uppercase << hex << (PCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(PCP44-4) >> 2] << " :: " << Inss[(PCP44-4) >> 2] << endl;
    ofTemp << setfill('0') << setw(8) << uppercase << hex << (PCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(PCP44-4) >> 2] << " :: " << Inss[(PCP44-4) >> 2] << endl;
}

if(sPCP44 == 0){
    cout << "\n";
    ofTemp << "\n";
}else if (state34){
    cout << " " << setfill('0') << setw(8) << uppercase << hex << (PCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(PCP44-4) >> 2] << " :: " << Inss[(PCP44-4) >> 2] << endl;
    ofTemp << " " << setfill('0') << setw(8) << uppercase << hex << (PCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(PCP44-4) >> 2] << " :: " << Inss[(PCP44-4) >> 2] << endl;
}else{
    cout << " " << setfill('0') << setw(8) << uppercase << hex << (sPCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(sPCP44-4) >> 2] << " :: " << Inss[(sPCP44-4) >> 2] << endl;
    ofTemp << " " << setfill('0') << setw(8) << uppercase << hex << (sPCP44-4) << " :: " << setw(8) << uppercase << hex << IMem[(sPCP44-4) >> 2] << " :: " << Inss[(sPCP44-4) >> 2] << endl;
}


//CHANGE THIS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

//cout << hex << "INST1: " << INST1 << '\t' << "INST14: " << INST14 <<  '\t' << "INST18: " << INST18 <<  '\n';
//cout << "INST2: " << INST2 << '\t' << "INST24: " << INST24 <<  '\t' << "INST28: " << INST28 <<  '\n';
//cout << "INST3: " << INST3 << '\n';
//cout << "INST4: " << INST4 << '\n';
//cout << "Flush" << Iflush1 << "Stall" << stall1 << "\n";
//cout << "PCP43: " << PCP43 << "\n";


//cout << setfill('_') << setw(80) << "_" << "\n";
//ofTemp << setfill('_') << setw(80) << "_" << "\n";

    ofTemp.close();ofTemp.clear();

    ifTemp.open("temp.txt");

    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    getline(ifTemp, sTemp);sOutput.append(sTemp);
    sOutput.append("\r\n");
    ifTemp.close();
    ifTemp.clear();
}

void clock1(){
_int32 temp1, temp2 = 0;
_int64 tempm1, tempm2 = 0;

//MemWB Reg
state35=state34;
PCP45=PCP44;
INST5=INST4;
sPCP45=sPCP44;
ALUout5=ALUout4;
RegWrite5=RegWrite4;
RegDst5=RegDst4;
Memtoreg5=Memtoreg4;
lw5=lw4;
Jump5=Jump4;
molo5=molo4;
mohi5=mohi4;
hilo5=hilo4;
if(((ALUout4) & ~((DMSize << 2)-1)) == ~((DMSize << 2)-1)){
temp1 = (ALUout4 >> 2) & (DMSize-1);
RamData=DMem[temp1];
RamOut=RamData;
}

//ExMem Reg
state34=state33;
PCP44=PCP43;
INST4=INST3;
sPCP44=sPCP43;
inRamData=rt;
ALUout4=ALUout3;
RegWrite4=RegWrite3;
RegDst4=RegDst3;
Memtoreg4=Memtoreg3;
lw4=lw3;
sw4=sw3;
Jump4=Jump3;
mult4=mult3;
multa4=multa3;
molo4=molo3;
mohi4=mohi3;
prod4=prod3;
Iflush4=Iflush3;
stall4=stall3;

//IDEX Reg
state33=state32;
PCP43=PCP42;
INST3=INST2;
sPCP43=sPCP42;
SEIM3=SEIM2;
rs=Q0;
rt=Q1;
ALUctr3=ALUctr2;
RegWrite3=RegWrite2;
RegDst3=RegDst2;
ALUsrc3=ALUsrc2;
Memtoreg3=Memtoreg2;
lw3=lw2;
sw3=sw2;
Jump3=Jump2;
mult3=mult2;
multa3=multa2;
molo3=molo2;
mohi3=mohi2;
Iflush3=Iflush2;
stall3=stall2;

//IFID Reg
Iflush2=Iflush1;
stall2=stall1;

state32 = 0;
if(state == 1){         //state B
    INST2=INST24;
    PCP42=PCP42+4;
    sPCP42=PCP42+4;
}else if(state == 2){   //state C
    INST2=INST24;
    PCP42=PCP42+4;
    sPCP42=0;
}else if(state == 3){   //state D
    state32=1;
    INST2=INST28;
    sPCP42=PCP42+4;
    PCP42=PCP42+8;
}else{                  //state A
    sPCP42=0;
    if(Iflush1||stall2){INST2=0;INST24=0;INST28=0;}else{INST2=INST1;INST24=INST14;INST28=INST18;PCP42=PCP41;}
}

if(INST5 != 0){     //If instruction 5 was a zero it was a flush or a stall not an instruction
    InsCnt++;
}

if(sPCP45 != 0){
    InsCnt++;
}


//controller
temp1 = getop(INST2);
temp2 = getfunc(INST2);
if(temp1 == 0 || temp1 == 8 || temp1 == 9 || temp1 == 12 || temp1 == 13 || temp1 == 3){RegWrite2 = 1;}else{RegWrite2 = 0;}
if(temp1 == 0){RegDst2 = 1;}else{RegDst2 = 0;}
if(temp1 == 8 || temp1 == 9 || temp1 == 12 || temp1 == 13 || temp1 == 35 || temp1 == 43){ALUsrc2 = 1;}else{ALUsrc2 = 0;}
if(temp1 == 35){Memtoreg2 = 1;}else{Memtoreg2 = 0;}
if(temp1 == 35){lw2 = 1;}else{lw2 = 0;}
if(temp1 == 43){sw2 = 1;}else{sw2 = 0;}
if(temp1 == 2 || temp1 == 3){Jump2 = 1;}else{Jump2 = 0;}
if(getop(INST24) == 2 || temp1 == 3){Jump24 = 1;}else{Jump24 = 0;}
if(getop(INST28) == 2 || temp1 == 3){Jump28 = 1;}else{Jump28 = 0;}

if(temp1 == 0 && temp2 == 24){mult2 = 1;}else{mult2 = 0;}
if(temp1 == 0 && temp2 == 28){multa2 = 1;}else{multa2 = 0;}
if(temp1 == 0 && temp2 == 18){molo2 = 1;}else{molo2 = 0;}
if(temp1 == 0 && temp2 == 16){mohi2 = 1;}else{mohi2 = 0;}
if(temp1 == 0 || temp1 == 8 || temp1 == 9 || temp1 == 4 || temp1 == 5 || temp1 == 35 || temp1 == 43 || temp1 == 16 || temp1 == 17){sext = 1;}else{sext = 0;}

if(temp1 == 4){Beq = 1;}else{Beq = 0;}
if(getop(INST24) == 4){Beq4 = 1;}else{Beq4 = 0;}
if(getop(INST28) == 4){Beq8 = 1;}else{Beq8 = 0;}

if(temp1 == 5){Bne = 1;}else{Bne = 0;}
if(getop(INST24) == 5){Bne4 = 1;}else{Bne4 = 0;}
if(getop(INST28) == 5){Bne8 = 1;}else{Bne8 = 0;}

if(temp1 == 16){Bgt = 1;}else{Bgt = 0;}
if(getop(INST24) == 16){Bgt4 = 1;}else{Bgt4 = 0;}
if(getop(INST28) == 16){Bgt8 = 1;}else{Bgt8 = 0;}

if(temp1 == 17){Blt = 1;}else{Blt = 0;}
if(getop(INST24) == 17){Blt4 = 1;}else{Blt4 = 0;}
if(getop(INST28) == 17){Blt8 = 1;}else{Blt8 = 0;}

if(temp1 == 0 && (INST2 & 0x0000003f) == 8){JR = 1;}else{JR = 0;}
if(getop(INST24) == 0 && (INST24 & 0x0000003f) == 8){JR4 = 1;}else{JR4 = 0;}
if(getop(INST28) == 0 && (INST28 & 0x0000003f) == 8){JR8 = 1;}else{JR8 = 0;}

if(temp1 == 0){
    ALUop = 2;
}else if(temp1 == 12){
    ALUop = 4;
}else if(temp1 == 13){
    ALUop = 5;
}else if(temp1 == 4 || temp1 == 5){
    ALUop = 1;
}else{
    ALUop = 0;
}

temp1 = getop(INST24);
if(temp1 == 0 || temp1 == 8 || temp1 == 9 || temp1 == 4 || temp1 == 5 || temp1 == 35 || temp1 == 43 || temp1 == 16 || temp1 == 17){sext4 = 1;}else{sext4 = 0;}
temp1 = getop(INST28);
if(temp1 == 0 || temp1 == 8 || temp1 == 9 || temp1 == 4 || temp1 == 5 || temp1 == 35 || temp1 == 43 || temp1 == 16 || temp1 == 17){sext8 = 1;}else{sext8 = 0;}



//Reset all forward conditions
for(int i=0; i<60; i++){
    forward[i]=0;
}

if(getrd(INST4)==getrs(INST3) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[1]=1;
    }
}else if(getrt(INST4)==getrs(INST3) && (getrt(INST4) !=0)){
    if(nit(INST4) && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[1]=1;
    }
}

if(getrd(INST4)==getrt(INST3) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (nrt(INST3)||sw3||mult3||multa3)){
        forward[2]=1;
    }
}else if(getrt(INST4)==getrt(INST3) && (getrt(INST4) !=0)){
    if(nit(INST4) && (nrt(INST3)||sw3||mult3||multa3)){
        forward[2]=1;
    }
}

if(getrd(INST5)==getrs(INST3) && (getrd(INST5) !=0)){
    if(nrt(INST5) && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[3]=1;
    }
}else if(getrt(INST5)==getrs(INST3) && (getrt(INST5) !=0)){
    if(nit(INST5) && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[3]=1;
    }
    if(loadw(INST5) && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[3]=1;
    }
}

if(getrd(INST5)==getrt(INST3) && (getrd(INST5) !=0)){
    if(nrt(INST5) && (nrt(INST3)||sw3||mult3||multa3)){
        forward[4]=1;
    }
}else if(getrt(INST5)==getrt(INST3) && (getrt(INST5) !=0)){
    if(nit(INST5) && (nrt(INST3)||sw3||mult3||multa3)){
        forward[4]=1;
    }
    if(loadw(INST5) && (nrt(INST3)||sw3||mult3||multa3)){
        forward[4]=1;
    }
}

if(getrt(INST5)==getrt(INST4) && (getrt(INST5) !=0)){
    if(lw5 && sw4){
        forward[7]=1;
    }
}

if(getrd(INST4)==getrs(INST2) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (jrin(INST2)||bri(INST2))){
        forward[8]=1;
    }
}else if(getrt(INST4)==getrs(INST2) && (getrt(INST4) !=0)){
    if(nit(INST4) && (jrin(INST2)||bri(INST2))){
        forward[8]=1;
    }
}

if(getrd(INST4)==getrs(INST24) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (jrin(INST24)||bri(INST24))){
        forward[43]=1;
    }
}else if(getrt(INST4)==getrs(INST24) && (getrt(INST4) !=0)){
    if(nit(INST4) && (jrin(INST24)||bri(INST24))){
        forward[43]=1;
    }
}

if(getrd(INST4)==getrs(INST28) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (jrin(INST28)||bri(INST28))){
        forward[53]=1;
    }
}else if(getrt(INST4)==getrs(INST28) && (getrt(INST4) !=0)){
    if(nit(INST4) && (jrin(INST28)||bri(INST28))){
        forward[53]=1;
    }
}

if(getrt(INST4)==getrs(INST2) && (getrt(INST4) !=0)){
    if(lw4&&jrin(INST2)){
        forward[9]=1;
    }
}

if(getrt(INST4)==getrs(INST24) && (getrt(INST4) !=0)){
    if(lw4&&jrin(INST24)){
        forward[5]=1;
    }
}

if(getrt(INST4)==getrs(INST28) && (getrt(INST4) !=0)){
    if(lw4&&jrin(INST28)){
        forward[6]=1;
    }
}

if(getrd(INST4)==getrt(INST2) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (bri(INST2))){
        forward[10]=1;
    }
}else if(getrt(INST4)==getrt(INST2) && (getrt(INST4) !=0)){
    if(nit(INST4) && (bri(INST2))){
        forward[10]=1;
    }
}

if(getrd(INST4)==getrt(INST24) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (bri(INST24))){
        forward[47]=1;
    }
}else if(getrt(INST4)==getrt(INST24) && (getrt(INST4) !=0)){
    if(nit(INST4) && (bri(INST24))){
        forward[47]=1;
    }
}

if(getrd(INST4)==getrt(INST28) && (getrd(INST4) !=0)){
    if(nrt(INST4) && (bri(INST28))){
        forward[57]=1;
    }
}else if(getrt(INST4)==getrt(INST28) && (getrt(INST4) !=0)){
    if(nit(INST4) && (bri(INST28))){
        forward[57]=1;
    }
}




if(31==getrs(INST3)){
    if(getop(INST4)==3 && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[21]=1;
    }
}

if(31==getrt(INST3)){
    if(getop(INST4)==3 && (nrt(INST3)||sw3||mult3||multa3)){
        forward[22]=1;
    }
}

if(31==getrs(INST3)){
    if(getop(INST5)==3 && (nrt(INST3)||nit(INST3)||lw3||sw3||mult3||multa3)){
        forward[23]=1;
    }
}

if(31==getrt(INST3)){
    if(getop(INST5)==3 && (nrt(INST3)||sw3||mult3||multa3)){
        forward[24]=1;
    }
}

if(31==getrs(INST2)){
    if(getop(INST3)==3 && (jrin(INST2)||bri(INST2))){
        forward[27]=1;
    }
}

if(31==getrs(INST2)){
    if(getop(INST4)==3 && (jrin(INST2)||bri(INST2))){
        forward[28]=1;
    }
}

if(31==getrt(INST2)){
    if(getop(INST3)==3 && bri(INST2)){
        forward[29]=1;
    }
}

if(31==getrt(INST2)){
    if(getop(INST4)==3 && (bri(INST2))){
        forward[30]=1;
    }
}



if(31==getrs(INST24)){
    if(getop(INST3)==3 && (jrin(INST24)||bri(INST24))){
        forward[42]=1;
    }
}

if(31==getrs(INST24)){
    if(getop(INST4)==3 && (jrin(INST24)||bri(INST24))){
        forward[44]=1;
    }
}

if(31==getrt(INST24)){
    if(getop(INST3)==3 && bri(INST24)){
        forward[48]=1;
    }
}

if(31==getrt(INST24)){
    if(getop(INST4)==3 && (bri(INST24))){
        forward[49]=1;
    }
}



if(31==getrs(INST28)){
    if(getop(INST3)==3 && (jrin(INST28)||bri(INST28))){
        forward[52]=1;
    }
}

if(31==getrs(INST28)){
    if(getop(INST4)==3 && (jrin(INST28)||bri(INST28))){
        forward[54]=1;
    }
}

if(31==getrt(INST28)){
    if(getop(INST3)==3 && bri(INST28)){
        forward[58]=1;
    }
}

if(31==getrt(INST28)){
    if(getop(INST4)==3 && (bri(INST28))){
        forward[59]=1;
    }
}


if(getrd(INST4)==getrs(INST3) && (getrd(INST4) !=0)){
    if(mohi4 && (nrt(INST3)||nit(INST3)||lw3||sw3)){
        forward[11]=1;
        }
}else if(getrd(INST5)==getrs(INST3) && (getrd(INST5) !=0)){
    if(mohi5 && (nrt(INST3)||nit(INST3)||lw3||sw3)){
        forward[11]=1;
    }
}

if(getrd(INST4)==getrt(INST3) && (getrd(INST4) !=0)){
    if(mohi4 && (nrt(INST3)||sw3)){
        forward[12]=1;
        }
}else if(getrd(INST5)==getrt(INST3) && (getrd(INST5) !=0)){
    if(mohi5 && (nrt(INST3)||sw3)){
        forward[12]=1;
    }
}

if(getrd(INST3)==getrs(INST2) && (getrd(INST3) !=0)){
    if(mohi3 && (jrin(INST2) || bri(INST2)) && mult4){
        forward[17]=1;
    }
}

if(getrd(INST3)==getrt(INST2) && (getrd(INST3) !=0)){
    if(mohi3 && (bri(INST2)) && mult4){
        forward[19]=1;
    }
}

if(getrd(INST3)==getrs(INST24) && (getrd(INST3) !=0)){
    if(mohi3 && (jrin(INST24) || bri(INST24)) && mult4){
        forward[40]=1;
    }
}

if(getrd(INST3)==getrt(INST24) && (getrd(INST3) !=0)){
    if(mohi3 && (bri(INST24)) && mult4){
        forward[45]=1;
    }
}

if(getrd(INST3)==getrs(INST28) && (getrd(INST3) !=0)){
    if(mohi3 && (jrin(INST28) || bri(INST28)) && mult4){
        forward[50]=1;
    }
}

if(getrd(INST3)==getrt(INST28) && (getrd(INST3) !=0)){
    if(mohi3 && (bri(INST28)) && mult4){
        forward[55]=1;
    }
}

if(getrd(INST4)==getrs(INST3) && (getrd(INST4) !=0)){
    if(molo4 && (nrt(INST3)||nit(INST3)||lw3||sw3)){
        forward[31]=1;
        }
}else if(getrd(INST5)==getrs(INST3) && (getrd(INST5) !=0)){
    if(molo5 && (nrt(INST3)||nit(INST3)||lw3||sw3)){
        forward[31]=1;
    }
}

if(getrd(INST4)==getrt(INST3) && (getrd(INST4) !=0)){
    if(molo4 && (nrt(INST3)||sw3)){
        forward[32]=1;
        }
}else if(getrd(INST5)==getrt(INST3) && (getrd(INST5) !=0)){
    if(molo5 && (nrt(INST3)||sw3)){
        forward[32]=1;
    }
}

if(getrd(INST3)==getrs(INST2) && (getrd(INST3) !=0)){
    if(molo3 && (jrin(INST2) || bri(INST2)) && mult4){
        forward[37]=1;
    }
}

if(getrd(INST3)==getrt(INST2) && (getrd(INST3) !=0)){
    if(molo3 && (bri(INST2)) && mult4){
        forward[39]=1;
    }
}

if(getrd(INST3)==getrs(INST24) && (getrd(INST3) !=0)){
    if(molo3 && (jrin(INST24) || bri(INST24)) && mult4){
        forward[41]=1;
    }
}

if(getrd(INST3)==getrt(INST24) && (getrd(INST3) !=0)){
    if(molo3 && (bri(INST24)) && mult4){
        forward[46]=1;
    }
}

if(getrd(INST3)==getrs(INST28) && (getrd(INST3) !=0)){
    if(molo3 && (jrin(INST28) || bri(INST28)) && mult4){
        forward[51]=1;
    }
}

if(getrd(INST3)==getrt(INST28) && (getrd(INST3) !=0)){
    if(molo3 && (bri(INST28)) && mult4){
        forward[56]=1;
    }
}


//execute stage5

//WBData5
tempm1 = hilo5 >> 32;
tempm2 = hilo5 & 0x00000000ffffffff;
if(Memtoreg5){
	WBData5 = RamData;
}else if(Jump5){
	WBData5 = PCP45;
}else if(mohi5){
	WBData5 = _int32(tempm1);
}else if(molo5){
	WBData5 = _int32(tempm2);
}else{
	WBData5 = ALUout5;
}

//WE5
if(Memtoreg5){
	WE5 = (lw5 && ((ALUout5 & ~((DMSize << 2)-1)) == ~((DMSize << 2) -1)));
}else{
	WE5 = RegWrite5;
}

//RD5
if(RegDst5){
	RD5 = getrd(INST5);
}else if(Jump5){
	RD5 = 31;
}else{
	RD5 = getrt(INST5);
}

//update register file
if(WE5 && (RD5 != 0)){
	regFile[RD5]=WBData5;
}
hilo = hilo5;


//execute stage4

//hilo4
if(multa4){
	hilo4 = hilo4 + prod4;
}else if(mult4){
	hilo4 = prod4;
}

if(forward[7]){
    inRamData = RamData;
}


//DataMem
if(sw4 && ((ALUout4) & ~((DMSize << 2)-1)) == ~((DMSize << 2)-1)){
    temp1 = (ALUout4 >> 2) + (DMSize);
	DMem[temp1]= inRamData;
}


//execute stage3
if(forward[1]){
    rs=ALUout4;
}else if(forward[21]){
    rs=PCP44;
}else if(forward[11] || forward[13]){
    rs= _int32(hilo5 >> 32);
}else if(forward[31] || forward[33]){
    rs= _int32(hilo5 & 0x00000000ffffffff);
}else if(forward[3]){
    rs=WBData5;
}else if(forward[23]){
    rs=PCP45;
}



if(forward[2]){
    rt=ALUout4;
}else if(forward[22]){
    rt=PCP44;
}else if(forward[12] || forward[14]){
    rt= _int32(hilo5 >> 32);
}else if(forward[32] || forward[34]){
    rt= _int32(hilo5 & 0x00000000ffffffff);
}else if(forward[4]){
    rt=WBData5;
}else if(forward[24]){
    rt=PCP45;
}

//ALU
if(ALUsrc3){temp1 = SEIM3;}else{temp1 = rt;}
if(ALUctr3 == 6){
	ALUout3 = rs - temp1;
}else if(ALUctr3 == 0){
	ALUout3 = (rs & temp1);
}else if(ALUctr3 == 1){
	ALUout3 = (rs | temp1);
}else if(ALUctr3 == 12){
	ALUout3 = ~(rs | temp1);
}else if(ALUctr3 == 17){
	temp2 = INST3 << 21;
	temp2 = temp2 >> 27;
	temp2 = temp2 & 31;
	ALUout3 = temp1 << temp2;
}else if(ALUctr3 == 16){
	temp2 = INST3 << 21;
	temp2 = temp2 >> 27;
	temp2 = temp2 & 31;
	ALUout3 = temp1 >> temp2;
}else{
	ALUout3 = rs + temp1;
}

//mult
prod3 = (long long)rs*rt;

//execute stage2



    temp1 = getop(INST2);
    temp2 = getfunc(INST2);
    if((ALUop == 2 && (temp2 == 34 || temp2 == 35)) || ALUop == 1){
        ALUctr2 = 6;
    }else if(ALUop == 2 && temp2 == 36){
        ALUctr2 = 0;
    }else if((ALUop == 2 && temp2 == 37) || ALUop == 5){
        ALUctr2 = 1;
    }else if(ALUop == 2 && temp2 == 39){
        ALUctr2 = 12;
    }else if(ALUop == 2 && temp2 == 0){
        ALUctr2 = 17;
    }else if(ALUop == 2 && temp2 == 2){
        ALUctr2 = 16;
    }else{
        ALUctr2 = 2;
    }


    //extender
    if(sext){
        SEIM2 = INST2 << 16;
        SEIM2 = SEIM2 >> 16;
    }else{
        SEIM2 = INST2 & 0x0000ffff;
    }
    if(sext4){
        SEIM24 = INST24 << 16;
        SEIM24 = SEIM24 >> 16;
    }else{
        SEIM24 = INST24 & 0x0000ffff;
    }
    if(sext8){
        SEIM28 = INST28 << 16;
        SEIM28 = SEIM28 >> 16;
    }else{
        SEIM28 = INST28 & 0x0000ffff;
    }


    //registerfile
    Q0 = INST2 << 6;
    Q0 = Q0 >> 27;
    Q0 = Q0 & 31;
    Q0 = regFile[Q0];
    Q1 = INST2 << 11;
    Q1 = Q1 >> 27;
    Q1 = Q1 & 31;
    Q1 = regFile[Q1];
    Q2 = INST24 << 6;
    Q2 = Q2 >> 27;
    Q2 = Q2 & 31;
    Q2 = regFile[Q2];
    Q3 = INST24 << 11;
    Q3 = Q3 >> 27;
    Q3 = Q3 & 31;
    Q3 = regFile[Q3];
    Q4 = INST28 << 6;
    Q4 = Q4 >> 27;
    Q4 = Q4 & 31;
    Q4 = regFile[Q4];
    Q5 = INST28 << 11;
    Q5 = Q5 >> 27;
    Q5 = Q5 & 31;
    Q5 = regFile[Q5];


     if(forward[17]){
        Q0=_int32(prod4 >> 32);
    }else if(forward[37]){
        Q0=_int32(prod4 & 0x00000000ffffffff);
    }else if(forward[27]){
        Q0=PCP43;
    }else if(forward[8]){
        Q0=ALUout4;
    }else if(forward[28]){
        Q0=PCP44;
    }


    if(forward[19]){
        Q1=_int32(prod4 >> 32);
    }else if(forward[39]){
        Q1=_int32(prod4 & 0x00000000ffffffff);
    }else if(forward[10]){
        Q1=ALUout4;
    }else if(forward[29]){
        Q1=PCP43;
    }else if(forward[30]){
        Q1= PCP44;
    }


     if(forward[40]){
        Q2=_int32(prod4 >> 32);
    }else if(forward[41]){
        Q2=_int32(prod4 & 0x00000000ffffffff);

    }else if(forward[42]){
        Q2=PCP43;

    }else if(forward[43]){
        Q2=ALUout4;

    }else if(forward[44]){
        Q2=PCP44;

    }


    if(forward[45]){
        Q3=_int32(prod4 >> 32);
    }else if(forward[46]){
        Q3=_int32(prod4 & 0x00000000ffffffff);
    }else if(forward[47]){
        Q3=ALUout4;
    }else if(forward[48]){
        Q3=PCP43;
    }else if(forward[49]){
        Q3= PCP44;
    }

     if(forward[50]){
        Q4=_int32(prod4 >> 32);
    }else if(forward[51]){
        Q4=_int32(prod4 & 0x00000000ffffffff);
    }else if(forward[52]){
        Q4=PCP43;
    }else if(forward[53]){
        Q4=ALUout4;
    }else if(forward[54]){
        Q4=PCP44;
    }


    if(forward[55]){
        Q5=_int32(prod4 >> 32);
    }else if(forward[56]){
        Q5=_int32(prod4 & 0x00000000ffffffff);
    }else if(forward[57]){
        Q5=ALUout4;
    }else if(forward[58]){
        Q5=PCP43;
    }else if(forward[59]){
        Q5= PCP44;
    }



    //comparitors
    if((Q0-Q1)==0){zero=1;}else{zero=0;}
    if((Q0 >> 31) == -1 && (Q1 >> 31) == 0){
        neg = 1;
    }else if((Q0 >> 31) == 0 && (Q1 >> 31) == -1){
        neg = 0;
    }else if((Q0-Q1)<0){
        neg=1;
    }else{
        neg=0;
    }


    if((Q2-Q3)==0){zero4=1;}else{zero4=0;}
    if((Q2 >> 31) == -1 && (Q3 >> 31) == 0){
        neg4 = 1;
    }else if((Q2 >> 31) == 0 && (Q3 >> 31) == -1){
        neg4 = 0;
    }else if((Q2-Q3)<0){
        neg4=1;
    }else{
        neg4=0;
    }



    if((Q4-Q5)==0){zero8=1;}else{zero8=0;}
    if((Q4 >> 31) == -1 && (Q5 >> 31) == 0){
        neg8 = 1;
    }else if((Q4 >> 31) == 0 && (Q5 >> 31) == -1){
        neg8 = 0;
    }else if((Q4-Q5)<0){
        neg8=1;
    }else{
        neg8=0;
    }


    //execute stage1
if (!stall2) {
    Branch=((Beq && zero) || (Bne && !zero) || (Blt && neg) || (Bgt && !neg && !zero)) && state == 0;
    Branch4=((Beq4 && zero4) || (Bne4 && !zero4) || (Blt4 && neg4) || (Bgt4 && !neg4 && !zero4)) && state == 0;
    Branch8=((Beq8 && zero8) || (Bne8 && !zero8) || (Blt8 && neg8) || (Bgt8 && !neg8 && !zero8)) && state == 0;

    Iflush1= (JR || Branch || Jump2) && state == 0;
    if(!Iflush2){

    //PC
    if(Jump2){
        temp1 = PCP42 & 0xf0000000;
        temp2 = (INST2 << 2) & 0x0ffffffc;
        CPC = temp2 + temp1;
    }else if(Branch){
        CPC = PCP42 + (SEIM2 << 2);
    }else if(JR){
        CPC = Q0;
    }else{
        CPC = PCP41;
    }




    if(forward[9] || forward[5] || forward[6]){
        CPC=RamOut;
    }

    if(state != 0){
        CPC = address2ID;
    }

    //IM
    temp1 = CPC >> 2;
    if((unsigned)temp1 < IMSize){
        INST1 = IMem[temp1];
    }
    temp1 = temp1 + 1;
    if((unsigned)temp1 < IMSize){
        INST14 = IMem[temp1];
    }
    temp1 = temp1 + 1;
    if((unsigned)temp1 < IMSize){
        INST18 = IMem[temp1];
    }
    PCP41=CPC+4;
    }
}

stall1=0;

if(state == 0){
if(getrs(INST1)==getrd(INST2) && (getrs(INST1) != 0)){
    if((jrin(INST1)||bri(INST1)) && nrt(INST2)){
        stall1=1;
    }else if((jrin(INST1)||bri(INST1)) && (molo2||mohi2) && (multa3)){
        stall1=1;
    }
}else if(getrs(INST1)==getrt(INST2) && (getrs(INST1) != 0)){
    if(lw2 && (nrt(INST1)||nit(INST1)||loadw(INST1)||storew(INST1)||jrin(INST1)||bri(INST1)||(getop(INST1)==0 && (getfunc(INST1)==28 || getfunc(INST1)==24)))){
        stall1=1;
    }else if((jrin(INST1)||bri(INST1)) && (nit(INST2))){
        stall1=1;
    }
}else if(getrt(INST1)==getrt(INST2) && (getrt(INST1) != 0)){
    if(lw2 && (nrt(INST1)||bri(INST1)||(getop(INST1)==0 && (getfunc(INST1)==28 || getfunc(INST1)==24)))){
        stall1=1;
    }else if((bri(INST1)) && (nit(INST2))){
        stall1=1;
    }
}else if(getrt(INST1)==getrd(INST2) && (getrt(INST1) != 0)){
    if(bri(INST1) && (nrt(INST2)||((mohi2||molo2)&&(multa3)))){
        stall1=1;
    }
}else if(getrs(INST1)==getrt(INST3) && (getrs(INST1) != 0)){
    if(lw3 && bri(INST1)){
        stall1=1;
    }
}else if(getrt(INST1)==getrt(INST3) && (getrt(INST1) != 0)){
    if(lw3 && bri(INST1)){
        stall1=1;
    }
}

opthaz24 = 0;
if(getrs(INST24)==getrd(INST3) && (getrs(INST24) != 0)){
    if((jrin(INST24)||bri(INST24)) && nrt(INST3)){
        opthaz24=1;
    }else if((jrin(INST24)||bri(INST24)) && (molo3||mohi3) && (multa4)){
        opthaz24=1;
    }
}else if(getrs(INST24)==getrt(INST3) && (getrs(INST24) != 0)){
    if(lw3 && (jrin(INST24)||bri(INST24))){
        opthaz24=1;
    }else if((jrin(INST24)||bri(INST24)) && (nit(INST3))){
        opthaz24=1;
    }
}else if(getrt(INST24)==getrt(INST3) && (getrt(INST24) != 0)){
    if(lw3 && bri(INST24)){
        opthaz24=1;
    }else if((bri(INST24)) && (nit(INST3))){
        opthaz24=1;
    }
}else if(getrt(INST24)==getrd(INST3) && (getrt(INST24) != 0)){
    if(bri(INST24) && (nrt(INST3)||((mohi3||molo3)&&(multa4)))){
        opthaz24=1;
    }
}else if(getrs(INST24)==getrt(INST3) && (getrs(INST24) != 0)){
    if(lw4 && bri(INST24)){
        opthaz24=1;
    }
}else if(getrt(INST24)==getrt(INST3) && (getrt(INST24) != 0)){
    if(lw4 && bri(INST24)){
        opthaz24=1;
    }
}



opthaz28 = 0;
if(getrs(INST28)==getrd(INST3) && (getrs(INST28) != 0)){
    if((jrin(INST28)||bri(INST28)) && nrt(INST3)){
        opthaz28=1;
    }else if((jrin(INST28)||bri(INST28)) && (molo3||mohi3) && (multa4)){
        opthaz28=1;
    }
}else if(getrs(INST28)==getrt(INST3) && (getrs(INST28) != 0)){
    if(lw3 && (jrin(INST28)||bri(INST28))){
        opthaz28=1;
    }else if((jrin(INST28)||bri(INST28)) && (nit(INST3))){
        opthaz28=1;
    }
}else if(getrt(INST28)==getrt(INST3) && (getrt(INST28) != 0)){
    if(lw3 && bri(INST28)){
        opthaz28=1;
    }else if((bri(INST28)) && (nit(INST3))){
        opthaz28=1;
    }
}else if(getrt(INST28)==getrd(INST3) && (getrt(INST28) != 0)){
    if(bri(INST28) && (nrt(INST3)||((mohi3||molo3)&&(multa4)))){
        opthaz28=1;
    }
}else if(getrs(INST28)==getrt(INST3) && (getrs(INST28) != 0)){
    if(lw4 && bri(INST28)){
        opthaz28=1;
    }
}else if(getrt(INST28)==getrt(INST3) && (getrt(INST28) != 0)){
    if(lw4 && bri(INST28)){
        opthaz28=1;
    }
}

oojrhaz = 0;
if(nrt(INST2) && (getrd(INST2)==getrs(INST28)) && (getrd(INST2) != 0)){
    oojrhaz = 1;
}else if(nrt(INST24) && (getrd(INST24)==getrs(INST28)) && (getrd(INST24) != 0)){
    oojrhaz = 1;
}else if((nit(INST2) || loadw(INST2)) && (getrt(INST2)==getrs(INST28)) && (getrt(INST2) != 0)){
    oojrhaz = 1;
}else if((nit(INST24) || loadw(INST24)) && (getrt(INST24)==getrs(INST28)) && (getrt(INST24) != 0)){
    oojrhaz = 1;
}else if((getop(INST24)==0 && (getfunc(INST24)== 16 || getfunc(INST24)== 18)) && (mult2 || multa2 || mult3 || multa3 || multa4) && (getrd(INST24)==getrs(INST28)) && (getrd(INST24) != 0)){
    oojrhaz = 1;
}else if((mohi2||molo2) && (mult3 || multa3 || multa4) && (getrd(INST2)==getrs(INST28)) && (getrd(INST2) != 0)){
    oojrhaz = 1;
}


oobhaz = 0;
if(nrt(INST2) && ((getrd(INST2)==getrs(INST28)) || (getrd(INST2)==getrt(INST28))) && (getrd(INST2) != 0)){
    oobhaz = 1;
}else if(nrt(INST24) && ((getrd(INST24)==getrs(INST28)) || (getrd(INST24)==getrt(INST28))) && (getrd(INST24) != 0)){
    oobhaz = 1;
}else if((nit(INST2) || loadw(INST2)) && ((getrt(INST2)==getrs(INST28)) || (getrt(INST2)==getrt(INST28))) && (getrt(INST2) != 0)){
    oobhaz = 1;
}else if((nit(INST24) || loadw(INST24)) && ((getrt(INST24)==getrs(INST28)) || (getrt(INST24)==getrt(INST28))) && (getrt(INST24) != 0)){
    oobhaz = 1;
}else if((getop(INST24)==0 && (getfunc(INST24)== 16 || getfunc(INST24)== 18)) && (mult2 || multa2 || mult3 || multa3 || multa4) && ((getrd(INST24)==getrs(INST28)) || (getrd(INST24)==getrt(INST28))) && (getrd(INST24) != 0)){
    oobhaz = 1;
}else if((mohi2||molo2) && (mult3 || multa3 || multa4) && ((getrd(INST2)==getrs(INST28)) || (getrd(INST2)==getrt(INST28))) && (getrd(INST2) != 0)){
    oobhaz = 1;
}


obohaz = 0;
if(getrs(INST28)==getrt(INST2) && (getrs(INST28) != 0)){
    if(lw2 && (nrt(INST28)||nit(INST28)||loadw(INST28)||storew(INST28)||(getop(INST28)==0 && (getfunc(INST28)==28 || getfunc(INST28)==24)))){
        obohaz=1;
    }
}else if(getrt(INST28)==getrt(INST2) && (getrt(INST28) != 0)){
    if(lw2 && (nrt(INST28)||(getop(INST28)==0 && (getfunc(INST28)==28 || getfunc(INST28)==24)))){
        obohaz=1;
    }
}


}

//state machine
cout << "STATE: " << (int)state << "\n";
if(state == 0){
    if((getop(INST2) == 3) || (getop(INST2) == 2) || (getop(INST2) == 0 && getfunc(INST2) == 8)){
cout << "//(jal x x) or (j x x) or (jr x x)";
        state = 0;
    }else if(bri(INST2)){
        if((getop(INST24) == 3) || (getop(INST24) == 2)){
cout << "//(branch jal x) or (branch j x)";
            if(stall1){
                state = 0;
            }else{
                if(Branch){
                    state = 0;
                }else{
                    state = 2;
                    temp1 = (PCP42+4) & 0xf0000000;
                    temp2 = (INST24 << 2) & 0x0ffffffc;
                    address2ID = temp2 + temp1;
                }
            }
        }else if((getop(INST24) == 0 && getfunc(INST24) == 8)){
cout << "//(branch jr x)";
                    if(Branch || stall1 || opthaz24){                   //CHANGE
                        state = 0;
                    }else{
                        state = 2;
                        address2ID = Q2;
                    }
        }else if(bri(INST24)){
            if((getop(INST28) == 2) || (getop(INST28) == 3)){
cout << "//(branch branch j) (branch branch jal)";
                    if(Branch){
                        state = 0;
                    }else{
                        if(stall1 || opthaz24){                     //CHANGE!!!!!!!!!!!
                            state = 0;
                        }else{
                            if(Branch4){
                                state = 2;
                                address2ID = PCP42 + 4 + (SEIM24 << 2);
                            }else{
                                state = 3;
                                temp1 = (PCP42+8) & 0xf0000000;
                                temp2 = (INST28 << 2) & 0x0ffffffc;
                                address2ID = temp2 + temp1;
                            }
                        }
                    }
            }else if(getop(INST28) == 0 && getfunc(INST28) == 8){
cout << "//(branch branch jr)";
                    if(Branch){
                        state = 0;
                    }else{
                        if(stall1 || opthaz24){                                         //CHANGE
                            state = 0;
                        }else{
                            if(Branch4){
                                state = 2;
                                address2ID = PCP42 + 4 + (SEIM24 << 2);
                            }else{
                                if(oojrhaz || opthaz28){
                                    state = 0;
                                }else{
                                    state = 1;
                                    address2ID = Q4;
                                }
                            }
                        }
                    }
            }else if(bri(INST28)){
cout << "//(branch branch branch)";
                    if(Branch){
                        state = 0;
                    }else{
                        if(stall1 || opthaz24){                                         //CHANGE
                            state = 0;
                        }else{
                            if(Branch4){
                                state = 2;
                                address2ID = PCP42 + 4 + (SEIM24 << 2);
                            }else{
                                if(opthaz28){
                                    state = 0;
                                }else{
                                    state = 1;
                                    if(Branch8){
                                        address2ID = PCP42 + 8 + (SEIM28 << 2);
                                    }else{
                                        address2ID =  PCP42 + 8;
                                    }
                                }
                            }
                        }
                    }
            }else{
cout << "//(branch branch other)";
                    if(Branch){
                        state = 0;
                    }else{
                        if(stall1 || opthaz24){                             //CHANGE
                            state = 0;
                        }else{
                            if(Branch4){
                                state = 2;
                                address2ID = PCP42 + 4 + (SEIM24 << 2);
                            }else{
                                state = 3;
                                address2ID = PCP42 + 8;
                            }
                        }
                    }
            }
        }else{
            if(getop(INST28) == 2){
cout << "//(branch other j)";
                   if(Branch || stall1){
                       state = 0;
                   }else{
                       state = 1;
                       temp1 = (PCP42+8) & 0xf0000000;
                       temp2 = (INST28 << 2) & 0x0ffffffc;
                       address2ID = temp2 + temp1;
                   }
            }else if(getop(INST28) == 3){
cout << "//(branch other jal)";
               state = 0;
            }else if(getop(INST28) == 0 && getfunc(INST28) == 8){
cout << "//(branch other jr)";
                   if(Branch || stall1){
                       state = 0;
                   }else{
                       if(oojrhaz || opthaz28){
                           state = 0;
                       }else{
                           state = 1;
                           address2ID = Q4;
                       }
                   }
            }else if(bri(INST28)){
cout << "//(branch other branch)";
                if(stall1){
                    state = 0;
                }else{
                    if(Branch){
                        state = 0;
                    }else{
                        if(oobhaz || opthaz28){
                            state = 0;
                        }else{
                            state = 1;
                            if(Branch8){
                                address2ID = PCP42 + 8 + (SEIM28 << 2);
                            }else{
                                address2ID = PCP42 + 8;
                            }
                        }
                    }
                }
            }else{
cout << "//(branch other other)";
                state = 0;
            }
        }
    }else{
         if((getop(INST24) == 3) || (getop(INST24) == 2)){
cout << "//(other jal x) or (other j x)";
            state = 2;
            temp1 = (PCP42+4) & 0xf0000000;
            temp2 = (INST24 << 2) & 0x0ffffffc;
            address2ID = temp2 + temp1;
        }else if((getop(INST24) == 0 && getfunc(INST24) == 8)){
cout << "//(other jr x)";
            if(stall1 || opthaz24){                         //CHANGE use to be (stall1 || opthaz){)
                state = 0;
            }else{
                state = 2;
                address2ID = Q2;
            }
        }else if(bri(INST24)){
            if((getop(INST28) == 2) || (getop(INST28) == 3)){
cout << "//(other branch j) or (other branch jal)";
                if(stall1 || opthaz24){                                     //CHANGE
                    state = 0;
                }else{
                    if(Branch4){
                        state = 2;
                        address2ID = PCP42 + 4 + (SEIM24 << 2);
                    }else{
                        state = 1;
                        temp1 = (PCP42+8) & 0xf0000000;
                        temp2 = (INST28 << 2) & 0x0ffffffc;
                        address2ID = temp2 + temp1;
                    }
                }
            }else if(getop(INST28) == 0 && getfunc(INST28) == 8){
cout << "//(other branch jr)";
                if(stall1 || opthaz24){                                     //CHANGE
                    state = 0;
                }else{
                    if(Branch4){
                        state = 2;
                        address2ID = PCP42 + 4 + (SEIM24 << 2);
                    }else{
                        if(oojrhaz || opthaz28){
                            state = 0;
                        }else{
                            state = 1;
                            address2ID = Q4;
                        }
                    }
                }
            }else if(bri(INST28)){
cout << "//(other branch branch)";
                if(stall1 || opthaz24){                 //CHANGE
                    state = 0;
                }else{
                    if(Branch4){
                        state = 2;
                        address2ID = PCP42 + 4 + (SEIM24 << 2);
                    }else{
                        if(opthaz28 || oobhaz){
                            state = 0;
                        }else{
                            state = 1;
                            if(Branch8){
                                address2ID = PCP42 + 8 + (SEIM28 << 2);
                            }else{
                                address2ID =  PCP42 + 8;
                            }
                        }
                    }
                }
            }else{
cout << "//(other branch other)";
              if(stall1 || opthaz24){                       //CHANGE
                    state = 0;
                }else{
                    cout << "Branch4: " << Branch4 << "\n";
                    cout << "Q2: " << Q2 << "\tQ3: " << Q3 << "\n";
                    cout << "forward[40]: " << forward[40] << "\n";
                    cout << "forward[41]: " << forward[41] << "\n";
                    cout << "forward[42]: " << forward[42] << "\n";
                    cout << "forward[43]: " << forward[43] << "\n";
                    cout << "forward[44]: " << forward[44] << "\n";
                    cout << "forward[45]: " << forward[45] << "\n";
                    cout << "forward[46]: " << forward[46] << "\n";
                    cout << "forward[47]: " << forward[47] << "\n";
                    cout << "forward[48]: " << forward[48] << "\n";
                    cout << "forward[49]: " << forward[49] << "\n";

                    if(Branch4){
                        state = 2;
                        address2ID = PCP42 + 4 + (SEIM24 << 2);
                    }else{
                        if(obohaz){
                            state = 0;
                        }else{
                            state = 3;
                            address2ID =  PCP42 + 8;
                        }
                    }
                }
            }
        }else{
            if(getop(INST28) == 2){
cout << "//(other other j)";
                state = 1;
                temp1 = (PCP42+8) & 0xf0000000;
                temp2 = (INST28 << 2) & 0x0ffffffc;
                address2ID = temp2 + temp1;
            }else if(getop(INST28) == 3){
cout << "//(other other jal)";
                state = 0;
            }else if(getop(INST28) == 0 && getfunc(INST28) == 8){
cout << "//(other other jr)";
                if(stall1 || opthaz28 || oojrhaz){
                    state = 0;
                }else{
                    state = 1;
                    address2ID = Q4;
                }
            }else if(bri(INST28)){
cout << "//(other other branch)";
                if(stall1 || opthaz28 || oobhaz){
                    state = 0;
                }else{
                    state = 1;
                    if(Branch8){
                        address2ID = PCP42 + 8 + (SEIM28 << 2);
                    }else{
                        address2ID =  PCP42 + 8;
                    }
                }
            }else{
cout << "//(other other other)";
                state = 0;
            }
        }
    }
}else{
    state = 0;
}
cout << "\n";

}   //End of clock1()


//FUNCTION INSTANTIATIONS
void resetMem(){
    for(unsigned int i=0; i<IMSize;i++){
        IMem[i] = 0;
        Inss[i] = "Empty";
    }
    Inss[IMSize] = "Program Complete";

    for(unsigned int i=0; i<32;i++) {
        regFile[i] =0;
    }

    for(unsigned int i=0; i<DMSize;i++){
        DMem[i] = 0;
    }
}

unsigned char getrs(_int32 x){
    x = x >> 21;
    x = x & 31;
    x = (unsigned char)x;
    return x;
}

unsigned char getrt(_int32 x){
    x = x >> 16;
    x = x & 31;
    x = (unsigned char)x;
    return x;
}

unsigned char getrd(_int32 x){
    x = x >> 11;
    x = x & 31;
    x = (unsigned char)x;
    return x;
}

_int32 getop(_int32 x){
    x = x >> 26;
    x = x & 63;
    return x;
}

_int32 getfunc(_int32 x){
    x = x & 63;
    return x;
}

bool nrt(_int32 x){
    _int32 op = getop(x);
    _int32 func = getfunc(x);

    if(op==0 && (func==0x20 || func==0x21 || func==0x24 || func==0x27 || func==0x25 || func==0x0 || func==0x2 || func==0x22 || func==0x23)){
        return 1;
    }else{
        return 0;
    }
}

bool nit(_int32 x){
    _int32 op = getop(x);

    if(op==8 || op==9 || op==0xc || op==0xd){
        return 1;
    }else{
        return 0;
    }
}

bool loadw(_int32 x){
    _int32 op = getop(x);

    if(op==0x23){
        return 1;
    }else{
        return 0;
    }
}

bool storew(_int32 x){
    _int32 op = getop(x);

    if(op==0x2b){
        return 1;
    }else{
        return 0;
    }
}

bool jrin(_int32 x){
    _int32 op = getop(x);
    _int32 func = getfunc(x);

    if(op==0 && func==8){
        return 1;
    }else{
        return 0;
    }
}

bool bri(_int32 x){
    _int32 op = getop(x);

    if(op==4 || op==5 || op==16 || op==17){
        return 1;
    }else{
        return 0;
    }
}
//END OF FUNCTION INSTANTIATIONS
